from izzylib import logging
from izzylib.http_signatures import generate_rsa_key
from izzylib.sql import Database

from .base import Session, tables
from .base import InstanceRow

from ..config import config, dbconfig


db = Database(
	config.dbtype,
	session_class = Session,
	row_classes = {
		'inbox': InstanceRow
	},
	**dbconfig
)

with db.session as s:
	try:
		version = s.get.config('version')

	except KeyError:
		version = 0

	if version == 0:
		keys = generate_rsa_key()
		db.create_database(tables)
		s.put.config('version', config.version)
		s.put.config('pubkey', keys.pubkey)
		s.put.config('privkey', keys.privkey)

	elif version < config.version:
		pass

	#for domain in ['barkshark.xyz', 'chomp.life']:
		#s.put.instance(f'https://{domain}/inbox', f'https://{domain}/actor')
