from izzylib import DotDict, logging


def cmd_actor(self, url):
	#cache = self.cache.actor_cache.fetch(url)

	#if cache:
		#return cache

	row = self.fetch('actor_cache', url=url)

	if not row:
		return

	data = DotDict(row.data)
	#self.cache.actor_cache.store(url, data)
	return data


def cmd_ban_list(self, types='domain'):
	if types == 'domain':
		return self.search('ban', handle=None, orderby='domain')

	bans = []

	for row in self.search('ban', orderby='domain'):
		if row.handle:
			bans.append(row)

	return bans


def cmd_ban(self, handle=None, domain=None):
	cache_key = f'{handle}{domain}'
	cache = self.cache.ban.fetch(cache_key)

	if cache:
		return cache

	if handle and not domain:
		row = self.fetch('ban', handle=handle)

	elif not handle and not domain:
		raise ValueError('handle or domain not specified')

	row = self.fetch('ban', handle=handle, domain=domain)
	self.cache.ban.store(cache_key, row)
	return row


def cmd_config(self, key):
	if key not in self.config_defaults:
		raise KeyError(f'Invalid config option: {key}')

	cache = self.cache.config.fetch(key)

	if cache:
		return cache

	row = self.fetch('config', key=key)

	if not row:
		return self.config_defaults[key][0]

	value = self.config_defaults[key][1](row.value)
	self.cache.config.store(key, value)
	return value


def cmd_config_all(self):
	data = DotDict()

	for key in self.config_defaults:
		data[key] = self.get.config(key)

	return data


def cmd_instance(self, data):
	for field in ['domain', 'inbox', 'actor']:
		row = self.fetch('inbox', **{field: data})

		if row:
			break

	return row


def cmd_instance_list(self, value=None):
	data = []

	if value not in [None, 'domain', 'inbox', 'actor']:
		raise ValueError('Invalid row data')

	for row in self.search('inbox'):
		if not row.followid:
			if value:
				data.append(row[value])

			else:
				data.append(row)

	return data


def cmd_inbox(self, *args, **kwargs):
	logging.warning('DeprecationWarning: session.get.inbox')
	return cmd_instance(*args, **kwargs)


def cmd_inbox_list(self, *args, **kwargs):
	logging.warning('DeprecationWarning: session.get.inbox_list')
	return cmd_instance_list(*args, **kwargs)


def cmd_retry(self, msgid, inbox):
	instance = self.get.instance(inbox)
	return instance.retry(msgid)
